package lrs.visitor;
import lrs.*;

/**
 * Check to see if the host is a palindrome.
 */
public class LRSPalindrome implements IAlgo {
    public static final LRSPalindrome Singleton = new LRSPalindrome();
    private LRSPalindrome() {}
    
    
    
    public Object emptyCase(LRStruct host, Object... nu) {
        return true;
    }
    
    public Object nonEmptyCase(LRStruct host, Object... nu) {
        LRStruct rev = (LRStruct) host.execute(LRSReverse.Singleton);
        return host.execute(LRSEqual.Singleton, rev);
    }
}