package lrs.visitor;
import lrs.*;

/**
 * Check to see if the host is a palindrome.
 */
public class IsPalindrome implements IAlgo {
    public static final IsPalindrome Singleton = new IsPalindrome();
    private IsPalindrome() {}
    
    
    
    public Object emptyCase(LRStruct host, Object... nu) {
        return true;
    }
    
    public Object nonEmptyCase(LRStruct host, Object... nu) {
        LRStruct rev = (LRStruct) host.execute(LRSReverse.Singleton);
        return host.execute(LRSEqual.Singleton, rev);
    }
}