
package tree;

public class Tree {
    private ATreeNode _rootNode;
    
    
    public Tree() {
        _rootNode = Empty.Singleton;
    }
    
    public Object getRoot() {
        return _rootNode.getRoot(this);
    }
    
    /**
     * @param dat 
     */
    public void setRoot(Object dat) {
        _rootNode.setRoot(this, dat);
    }
    
    /**
     * @param dat 
     */
    public void insertRoot(Object dat) {
        _rootNode.insertRoot(this, dat);
    }
    
    public void remRoot() {
        _rootNode.remRoot(this);
    }
    
    /**
     * @return 
     */
    public Tree get_leftMostChild() {
        return _rootNode.get_leftMostChild(this);
    }
    
    /**
     * @param  lmc leftMostChild 
     */
    public void set_leftMostChild(Tree lmc) {
        _rootNode.set_leftMostChild(this, lmc);
    }
    
    /**
     * @return 
     */
    public Tree get_rightSibling() {
        return _rootNode.get_rightSibling(this);
    }
    
    /**
     * @param rs 
     */
    public void set_rightSibling(Tree rs) {
        _rootNode.set_rightSibling(this, rs);
    }
}

